require({cache:{
'url:slmdx/form/templates/DropDownSelect.html':" <div>\n    <div class=\"form-control\"\n            data-dojo-attach-point=\"textbox, focusNode\"\n            data-dojo-attach-event=\"onclick:_onClick, onkeypress:_onKeyPress\" ${disabledTextSetting}>\n        <span class=\"caret\" data-dojo-attach-point=\"_caretNode\"></span>\n        <span class=\"form-text\" data-dojo-attach-point=\"textNode\"><span data-dojo-attach-point=\"_iconNode\"></span></span>\n        <input type=\"text\" style=\"display:none;\" autocomplete=\"off\" data-dojo-attach-point=\"valueNode\" ${!nameAttrSetting}>\n    </div>\n </div>"}});
define("slmdx/form/DropDownSelect", [
    'dojo/_base/declare',
    'dojo/_base/array',
    'dojo/_base/lang',
    'dojo/_base/window',
    'dojo/dom',
    'dojo/dom-attr',
    'dojo/dom-class',
    'dojo/dom-construct',
    'dojo/dom-style',
    'dojo/dom-geometry',
    'dojo/query',
    'dojo/keys',
    'dijit/popup',
    'dijit/form/_FormWidget',
    'dojo/text!./templates/DropDownSelect.html',
    "./_DropDownMenu",
    './_ComponentReadOnlyMixin',
    "../util/slmUtil",
    "../_base/ImageFactory",
    "../_base/_IconMixin"
], function(declare, array, lang, windowModule, dom, domAttr, domClass, domConstruct, domStyle, geometry, query, keys,
            popup, _FormWidget, template, _DropDownMenu, _ComponentReadOnlyMixin, slmUtil, ImageFactory, _IconMixin){

    var DropDownSelect = declare([_FormWidget, _ComponentReadOnlyMixin, _IconMixin], {
        templateString: template,
        baseClass: "dropdown-select",

        readOnly: false,
        disabled: false,
        required: false,
        error: "",

        boldItem: null,

        options: null,
        _opened: false,
        duplicateItem: false,
        disabledTextSetting: "",
        valueAsInnerText: true,

        buildRendering: function(){
            this._parseSource();

            this.defineTemplate();

            var value = "";
            if(this.readOnly) {
                var _this = this;
                array.forEach(this.options, function(option){
                    if(option.selected){
                        value = option.label;
                        _this.iconClass = option.iconClass;
                    }
                });
            }

            this.inherited(arguments);
            this.componentRendering(value);
        },

        postMixInProperties: function() {
            if (this.disabled) {
                this.disabledTextSetting = "disabled";
            }
            this.inherited(arguments);
            if (this.readOnly || this.disabled) {
                this.required = false;
            }
            if (this.required) {
                this.baseClass = this.baseClass + " required";
            }
        },

        postCreate: function() {
            if(this.readOnly) return;
            this._createDropDown();
            dom.setSelectable(this.domNode, false);
        },

        _fillContent: function() {
            this.inherited(arguments);
            if(this.readOnly) return;

            this.dropdown = new _DropDownMenu({
                onChange: lang.hitch(this, this._selectOption)
            });

            if (this.error) {
                this.state = "Error";
            }
        },

        // returns a list of DOM nodes of menu items
        getMenuItems: function() {
            return query(">", this.dropdown.domNode);
        },

        // dynamically adding option
        appendOption: function( label,  value, iconClass) {
            var s = this.duplicateItem;
            query("li", this.dropdown.domNode).forEach(function(node) {
                if ((node.getAttribute("hiddenValue") == value) && (node.lastChild.innerHTML == label))
                    s = true;
            })
            if (s) {
                this.duplicateItem = false;
                return;
            }

            var item = windowModule.doc.createElement("li");

            if (iconClass) {
                iconClass = ImageFactory.createIconCss(iconClass);
                var image = windowModule.doc.createElement("span");
                domAttr.set(image, "class", "menu-icon " + iconClass);
                item.appendChild(image);
            }
            if (label == '') {
                var text = windowModule.doc.createElement("span");
                text.innerHTML = "&nbsp";
                item.appendChild(text);
            } else if (label) {
                var text = windowModule.doc.createElement("span");
                text.innerHTML = label;
                item.appendChild(text);
            }
            if (value == '') {
                domAttr.set(item, "hiddenValue", "");
                var optsCount = this.dropdown.getOptionsCount();
                domAttr.set(item, "id", this.dropdown.domNode.id + optsCount);
                this.dropdown.setOptionsCount(optsCount + 1);
            } else if (!value) {
                domAttr.set(item, "hiddenValue", "");
                var optsCount = this.dropdown.getOptionsCount();
                domAttr.set(item, "id", this.dropdown.domNode.id + optsCount);
                this.dropdown.setOptionsCount(optsCount + 1);
            } else {
                domAttr.set(item, "hiddenValue", value);
                var optsCount = this.dropdown.getOptionsCount();
                domAttr.set(item, "id", this.dropdown.domNode.id + optsCount);
                this.dropdown.setOptionsCount(optsCount + 1);
            }
            item.className = "popup-menu-item";

            // if adding in an empty DropDownSelect
            if (!this.dropdown.domNode.firstChild) {
                this.textNode.innerHTML = item.innerHTML;
                this.valueNode.value = value;
                this.boldItem = item;
                this.valueNode.value = domAttr.get(item, "hiddenValue");
                this.dropdown.setOptionsCount(1);
            }

            this.dropdown.domNode.appendChild(item);
        },

        // dynamically removing option
        deleteOption: function(/*String*/ value) {
            var items = query("li", this.dropdown.domNode);
            var itemsCount = items.length;
            var optionToRemove = null;
            if (value == '') {
                value = "&nbsp;";
            }

            // searching for the option to remove
            array.forEach(items, function(item) {
                // searching by value
                if (domAttr.get(item, "hiddenValue") == value) {
                    optionToRemove = item;
                }
            })
            if (!optionToRemove) {
                // searching by label
                array.forEach(items, function(item) {
                    if (item.lastChild.innerHTML == value) {
                        optionToRemove = item;
                    }
                })
            }

            domConstruct.destroy(optionToRemove);
            if(optionToRemove != null) {
                this.dropdown.setOptionsCount(itemsCount - 1);
            }

            // actually removing option
            if (itemsCount == 1) {
                // if this option is the last
                this.textNode.innerHTML = "";
                this.valueNode.value = "";
            } else if (optionToRemove == this.dropdown.getCurrentOptionNode()) {
                // if this option is currently active
                this.textNode.innerHTML = this.dropdown.domNode.firstChild.innerHTML;
                this.boldItem = this.dropdown.domNode.firstChild;
                this.valueNode.value = domAttr.get(this.boldItem, "hiddenValue");
            }
        },

        _setSelected: function(/*DomNode*/ node) {
            this.dropdown.setCurrentOptionNode(node);
            this.textNode.innerHTML = node.innerHTML;
            if (this.boldItem) {
                this.boldItem = node;
                this.valueNode.value = domAttr.get(this.boldItem, "hiddenValue");
            }
        },

        _hideMenu: function() {
            if (this._opened) {
                popup.close(this.dropdown);
                this._opened = false;
            }
        },

        _onKeyPress: function(/*Event*/ evt) {
            var key = evt.charOrCode;
            var dd = this.dropdown;
            var dk = keys;
            if (this._opened) {
                dd.handleKey(key);
                curr = dd.currentNode;
            }
            switch (key) {
                case dk.PAGE_DOWN:
                case dk.DOWN_ARROW:
                    if (!this._opened) {
                        this._onClick();
                    }
                    break;

                case dk.ENTER:
                    // prevent submitting form if user presses enter. Also
                    // prevent accepting the value if either Next or Previous
                    // are selected
                    if (this._opened) {
                        if (curr) {
                            this.textNode.innerHTML = curr.innerHTML;
                            this.boldItem = curr;
                            this.valueNode.value = domAttr.get(curr, "hiddenValue");
                        }
                        this._hideMenu();
                        evt.preventDefault(), evt.stopPropagation();
                        this.onChange();
                    }
                    break;

                case dk.ESCAPE:
                    if (this._opened) {
                        evt.preventDefault(), evt.stopPropagation();
                        this._hideMenu();
                    }
                    break;
            }
        },

        _onBlur: function() {
            // summary:
            //		Called magically when focus has shifted away from this widget and it's drop down
            this._hideMenu();
            this.inherited(arguments);
        },

        _selectOption: function(evt) {
            this.dropdown.setCurrentOptionNode(evt);
            this.boldItem = evt;
            this.textNode.innerHTML = evt.innerHTML;
            this.valueNode.value = domAttr.get(evt, "hiddenValue");
            this._hideMenu();
            this.focus();
            this.onChange();
        },

        _createDropDown: function() {
            this.dropdown.createMenu(this.options);
            this.boldItem = this.dropdown.getCurrentOptionNode();

            if (this.options.length == 0) {
                return;
            }
            this.value = domAttr.get(this.boldItem, "hiddenValue");
            this.textNode.innerHTML = this.boldItem.innerHTML;
            this.valueNode.value = this.value;
        },

        _parseSource: function() {
            // summary:
            //		Loads our options and sets up our dropdown correctly.  We
            //		don't want any content, so we don't call any inherit chain
            //		function.
            var opts = this.options;
            if (!opts) {
                opts = this.options = this.srcNodeRef ? query(">",
                    this.srcNodeRef).map(function(node) {
                        return {
                            nullOption: node.getAttribute("nullOption") == null ? false : true,
                            hiddenValue: node.getAttribute("value"),
                            iconClass: node.getAttribute("iconClass"),
                            label: String(slmUtil.decodeHTMLEntities(node.innerHTML)),
                            selected: slmUtil.str2bool(domAttr.get(node, "selected")),
                            disabled: slmUtil.str2bool(domAttr.get(node, "disabled"))
                        };
                    }, this) : [];
            }
        },

        _onClick: function() {
            if (this.disabled || this.readOnly) {
                return;
            }
            if (this.dropdown.getOptionsCount() == 0) {
                return;
            }
            this.focus();
            if (this._opened) {
                this._hideMenu();
            } else {
                // forces full population of results, if they click
                // on the arrow it means they want to see more options
                this.focus();
                this._showMenu();
                this._opened = true;
                //this.button.setSelectedStyle(true); toda
            }
        },

        _showMenu: function() {
            this._hideMenu();
            domStyle.set(this.dropdown.domNode, {width: "", height: ""});

            var best = this._open();
            // #3212:
            //		only set auto scroll bars if necessary prevents issues with
            //		scroll bars appearing when they shouldn't when node is made
            //		wider (fractional pixels cause this)
            var popupbox = geometry.getMarginBox(this.dropdown.domNode);
            this.dropdown.domNode.style.overflow =
                ((best.h == popupbox.h) && (best.w == popupbox.w)) ? "hidden" : "auto";
            // #4134:
            //		borrow TextArea scrollbar test so content isn't covered by
            //		scrollbar and horizontal scrollbar doesn't appear

            // Defect 41847
            // Popup width is always as component width
/*            var newwidth = best.w;
            if (best.h < this.dropdown.domNode.scrollHeight) {
                newwidth += 16;
            }*/
            geometry.setMarginBox(this.dropdown.domNode, {
                h: best.h,
                w: this.domNode.offsetWidth
            });
            //var divInfo = geometry.position(this.dropdown.domNode, true);

        },

        _open: function() {
            var drop = this.dropdown;
            return popup.open({
                popup: drop,
                around: this.domNode,
                maxHeight: drop.domNode.scrollHeight,
                parent: this
            });
            this._opened = true;
        },

        destroy: function() {
            if(this.dropdown) {
                this.dropdown.destroy();
            }
            this.inherited(arguments);
        }

    });

    return DropDownSelect;
});
