define("slmdx/form/_ListBoxItem", [
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dojo/_base/window",
    "../util/slmUtil"
], function (declare, array, query, domClass, domConstruct, _Widget, _TemplatedMixin, win, slmUtil) {
    return declare([_Widget, _TemplatedMixin], {

        itemIndex: 0,
        itemLabel: "",
        parentNode: null,
        value: null,
        isSelected: false,
        templateString: '<li class="list-group-item" data-dojo-attach-event="onclick:_onClick"> </li>',

        _fillContent: function(){
            this.inherited(arguments);
            if(this.itemLabel) {
                domConstruct.place(win.doc.createTextNode(String(slmUtil.decodeHTMLEntities(this.itemLabel))), this.domNode, 0);
            }
        },

        _onClick: function(evt) {
            if (this.parentNode.disabled || this.parentNode.readOnly) {
                return;
            }
            this.parentNode.selectRow(this, evt);
        },

        setSelected: function(isSelect) {
            (isSelect) ? domClass.add(this.domNode, "selected") : domClass.remove(this.domNode, "selected");
        }
    });
});